%function[Weights_Model,SSE] = system_identification()

%clear all;
%clc;

% Direct modeling of Electrical system of the plant using RLS algorithm
% By Y.Yella Reddy, 08EE01015, SES, IIT Bhubaneswar.

%Plant Parameters

Weights_Plant=[0.26 0.93 0.26] ; % Transfer function coefficients
N=input('Enter the no of the iterations/input samples: '); %input number of samples.
Input_Plant= rand(1,N);  % input to the plant with mean zero and input to model is also same.


% Model Parameters-RLS and LMS
Weights_Model=[0 0 0];
Weights_Model1=[0 0 0];
Input_Model=Input_Plant;
Learning_Para=input('Enter the Learning Parameter value:'); % Learning rate of the model

%Signal Power to noise power
snr=input('Enter the snr value : ');

%Signal Power and Noise Power
sp=var(Input_Plant);
np =(sp)*power(10,-(snr/10)); 

%Noise to be added
Noise=sqrt(np)*(rand(1,N)-0.5);  


%--------------Intialization-------------%

    % Plant Output.
    Plant_Output(1)=Input_Plant(1)*Weights_Plant(1);
    Plant_Output(2)=Input_Plant(2)*Weights_Plant(1)+Input_Plant(1)*Weights_Plant(2);
    
    %Model Output-RLS
    Model_Output(1)=Input_Model(1)*Weights_Model(1);
    Model_Output(2)=Input_Model(2)*Weights_Model(1)+Input_Model(1)*Weights_Model(2);
    
    %Model Output-LMS
    Model_Output1(1)=Input_Model(1)*Weights_Model1(1);
    Model_Output1(2)=Input_Model(2)*Weights_Model1(1)+Input_Model(1)*Weights_Model1(2);
     
    % Plant output with added noise
    Plant_Output(1)=Plant_Output(1)+Noise(1);
    Plant_Output(2)=Plant_Output(2)+Noise(2);
     
    % Error-RLS
    error(1)=Plant_Output(1)-Model_Output(1);
    error(2)=Plant_Output(2)-Model_Output(2);
    
    % Error-LMS
    error1(1)=Plant_Output(1)-Model_Output1(1);
    error1(2)=Plant_Output(2)-Model_Output1(2);

     %Weight Values
    Weights_Model(1)=Weights_Model(1) + (2*Learning_Para*Input_Model(1)*error(1));
    Weights_Model(1:2)=Weights_Model(1:2) + (2*Learning_Para*Input_Model(2:-1:1)*error(2));
    
    
     %Weight Values
    Weights_Model1(1)=Weights_Model1(1) + (2*Learning_Para*Input_Model(1)*error1(1));
    Weights_Model1(1:2)=Weights_Model1(1:2) + (2*Learning_Para*Input_Model(2:-1:1)*error1(2));

    R_inverse=100*eye(3);%[1 0 0; 0 1 0;0 0 1];
%------Applying Adaptive LMS algorithm--------%    
for i=3:1:N
    
    %Outputs
    Plant_Output(i)=Input_Plant(i)*Weights_Plant(1)+Input_Plant(i-1)*Weights_Plant(2)+Input_Plant(i-2)*Weights_Plant(3);
    Model_Output(i)=Input_Model(i)*Weights_Model(1)+Input_Model(i-1)*Weights_Model(2)+Input_Model(i-2)*Weights_Model(3);
    Model_Output1(i)=Input_Model(i)*Weights_Model1(1)+Input_Model(i-1)*Weights_Model1(2)+Input_Model(i-2)*Weights_Model1(3);

    %White gaussian noise signal added to the output of the plant.
    Plant_Output(i)=Plant_Output(i)+Noise(i);
    error(i)=Plant_Output(i)-Model_Output(i);
    error1(i)=Plant_Output(i)-Model_Output1(i);
    
   
    %RLS algorithm parameters
    filtered_infrmn_vect=R_inverse*Input_Plant(i:-1:i-2)';
    norm_error_power=Input_Plant(i:-1:i-2)*filtered_infrmn_vect;
    gain_constant=1/(1+ norm_error_power);
    norm_filtered_infrmn_vect= gain_constant*filtered_infrmn_vect';
    
    %Weight Update using RLS algorithm
    Weights_Model=Weights_Model + error(i)*norm_filtered_infrmn_vect;%(2*Learning_Para*Input_Model(i:-1:i-2)*error(i));
    
    %Updating R inverse
    R_inverse= R_inverse-norm_filtered_infrmn_vect'*norm_filtered_infrmn_vect;
    
   
    %Weight Update using LMS algorithm
    Weights_Model1=Weights_Model1 + (2*Learning_Para*Input_Model(i:-1:i-2)*error1(i));

end

%Plots of error square and log of normalized error square

t=1:1:N;
error_square=power(error,2);
error_square1=power(error1,2);
Max_error_square=max(error_square);
Max_error_square1=max(error_square1);

Normalized_error_Square=error_square./Max_error_square;
Normalized_error_Square1=error_square1./Max_error_square1;

plot(t,error_square,'r-',t,error_square1,'g-');
legend('error square-RLS','error square-LMS');
title('Plot of error square Vs no of iterations');
xlabel('iterations');
ylabel('error square')

figure,
plot(t,10*(log10(Normalized_error_Square)),'r-',t,10*(log10(Normalized_error_Square1)),'g-');
legend('Normalized error square log-RLS','Normalized error square log-LMS');
title('Plot of Normalized error square log Vs no of iterations');
xlabel('iterations');
ylabel('Normalized error square log')


%----------------------Testing mode-------------%

s=30;
Input_test=rand(1,s);


for j= 3:1:s
    
    %RLS
    Plant_Out_test(1)=Input_test(1)*Weights_Plant(1);
    Plant_Out_test(2)=Input_test(2)*Weights_Plant(1)+Input_test(1)*Weights_Plant(2);
    Plant_Out_test(j)=Input_test(j)*Weights_Plant(1)+Input_test(j-1)*Weights_Plant(2)+Input_test(j-2)*Weights_Plant(3);
    
    Out_Model_test(1)=Input_test(1)*Weights_Model(1);
    Out_Model_test(2)=Input_test(2)*Weights_Model(1)+Input_test(1)*Weights_Model(2);
    Out_Model_test(j)= Input_test(j)*Weights_Model(1)+Input_test(j-1)*Weights_Model(2)+Input_test(j-2)*Weights_Model(3);
    
    %LMS
    Plant_Out_test1(1)=Input_test(1)*Weights_Plant(1);
    Plant_Out_test1(2)=Input_test(2)*Weights_Plant(1)+Input_test(1)*Weights_Plant(2);
    Plant_Out_test1(j)=Input_test(j)*Weights_Plant(1)+Input_test(j-1)*Weights_Plant(2)+Input_test(j-2)*Weights_Plant(3);
    
    Out_Model_test1(1)=Input_test(1)*Weights_Model1(1);
    Out_Model_test1(2)=Input_test(2)*Weights_Model1(1)+Input_test(1)*Weights_Model1(2);
    Out_Model_test1(j)= Input_test(j)*Weights_Model1(1)+Input_test(j-1)*Weights_Model1(2)+Input_test(j-2)*Weights_Model1(3);
    
    %RLS
    error_test(1)= Plant_Out_test(1)-Out_Model_test(1);
    error_test(2)= Plant_Out_test(2)-Out_Model_test(2);
    error_test(j)= Plant_Out_test(j)-Out_Model_test(j);
    
    %LMS
    error_test1(1)= Plant_Out_test1(1)-Out_Model_test1(1);
    error_test1(2)= Plant_Out_test1(2)-Out_Model_test1(2);
    error_test1(j)= Plant_Out_test1(j)-Out_Model_test1(j);
    
end

p=1:1:s;
figure,
plot(p,Plant_Out_test,'-ro',p,Out_Model_test,'-.b');
legend('Plant Out test','Out Model test');
title('Comparision of outputs of Plant and Model during testing-RLS');
xlabel('iterations');
ylabel('Output')

figure,
plot(p,Plant_Out_test1,'-ro',p,Out_Model_test1,'-.b');
legend('Plant Out test1','Out Model test1');
title('Comparision of outputs of Plant and Model during testing-LMS');
xlabel('iterations');
ylabel('Output')


square_error= error_test.^2;
SSE=sum(square_error);

display(SSE);
Weights_Model
Weights_Model1



%end